/**
 * blanche conseiller d'essence, inc. Copyright 2006-, all rights reserved.
 *
 * $Id: TestApplication.java,v 1.0, 2006-05-18 11:10:45Z, Ryosuke Iwata$
 * $Revision: 1$
 * $Date: 2006/05/18 20:10:45$
 * $Author: Ryosuke Iwata$$
 */
package gffktest.client;

import java.awt.Toolkit;
import java.awt.Dimension;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.ejb.*;
import gffktest.session.*;


/**
 * @author $Author: Ryosuke Iwata$
 * @version $Revision: 1$ - $Date: 2006/05/18 20:10:45$
 */
public class TestApplication {
    private boolean packFrame = false;

    @EJB
        static private TestSession mySessionBean;

    /**
     * @param args String[]
     */
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                try {
                    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                } catch (Exception exception) {
                    exception.printStackTrace();
                }

                new TestApplication();
            }
        });
    }

    public TestApplication() {
        TestAppFrame frame = new TestAppFrame();
        frame.setMySessionBean(mySessionBean);
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation( (screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }
}
