/**
 * blanche conseiller d'essence, inc. Copyright 2006-, all rights reserved.
 *
 * $Id: ContractTerms.java,v 1.0, 2006-05-18 11:10:45Z, Ryosuke Iwata$
 * $Revision: 1$
 * $Author: Ryosuke Iwata$
 */
package gffktest.entity;

import java.io.*;
import java.util.Date;
import javax.persistence.*;


/**
 * @author $Author: Ryosuke Iwata$
 * @version $Revision: 1$ - $Date: 2006/05/18 20:10:45$
 * @stereotype entity
 */
@Entity
    @Table(schema = PersistenceConstants.TABLE_SCHEMA)
    public class ContractTerms {

    public ContractTerms() {
    }

    public Long getId() {
        return id;
    }

    private void setId(Long id) {
        this.id = id;
    }

    public Program getProgram() {
        return program;
    }

    /**
     * Sets property &quot;program&quot; and maintains bi-directional relations.
     *
     * @param program Program to set.
     */
    public void setProgram(Program program) {
        Program formerParent = getProgram();
        if (formerParent != null) {
            formerParent.setContractTerms_internal(null);
        }
        setProgram_internal(program);
        if (program != null) {
            program.setContractTerms_internal(this);
        }
    }

    /**
     * Internal-use-only property setter for &quot;program&quot;
     * This method only sets the instance variable
     * and does not maintain bi-directional relations.
     *
     * @param program Program to set.
     */
    void setProgram_internal(Program program) {
        this.program = program;
    }

    static final private String _ID_GEN_NAME = "CONTRACT_TERMS_GEN";
    static final private String _ID_SEQ_NAME = "CONTRACT_TERMS_SEQ";
    @Id
        @SequenceGenerator(name = _ID_GEN_NAME, sequenceName = _ID_SEQ_NAME, allocationSize = 1)
        @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = _ID_GEN_NAME)
//        private Long id;
        private long id;

    @OneToOne(mappedBy = "contractTerms", optional = false)
        private Program program;

    @Version
        @Column(nullable = false)
        private Long objectVersion;
}
