/**
 * blanche conseiller d'essence, inc. Copyright 2006-, all rights reserved.
 *
 * $Id: Program.java,v 1.0, 2006-05-18 11:10:46Z, Ryosuke Iwata$
 * $Revision: 1$
 * $Author: Ryosuke Iwata$
 */
package gffktest.entity;

import java.io.*;
import java.util.*;
import java.util.logging.*;
import javax.persistence.*;


/**
 * @author $Author: Ryosuke Iwata$
 * @version $Revision: 1$ - $Date: 2006/05/18 20:10:46$
 * @stereotype entity
 */
@Entity
    @Table(schema = PersistenceConstants.TABLE_SCHEMA)
    public class Program {

    static private Logger getLogger() {
        return Logger.global;
    }

    public Program() {
        this.registeredDate = new Date();
    }

    public Long getId() {
        return id;
    }

    private void setId(Long id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Date getRegisteredDate() {
        return registeredDate;
    }

    private void setRegisteredDate(Date registeredDate) {
        this.registeredDate = registeredDate;
    }

    public ContractTerms getContractTerms() {
        return contractTerms;
    }

    /**
     * Sets property &quot;contractTerms&quot; and maintains bi-directional relations.
     *
     * @param terms ContractTerms to set.
     */
    public void setContractTerms(ContractTerms terms) {
        setContractTerms_internal(terms);
        if (terms != null) {
            terms.setProgram_internal(this);
        }
    }

    /**
     * Internal-use-only property setter for &quot;contractTerms&quot;
     * This method only sets the instance variable
     * and does not maintain bi-directional relations.
     *
     * @param terms ContractTerms to set.
     */
    void setContractTerms_internal(ContractTerms terms) {
        this.contractTerms = terms;
    }

    private Long getObjectVersion() {
        return objectVersion;
    }

    private void setObjectVersion(Long version) {
        objectVersion = version;
    }

    static final private String _ID_GEN_NAME = "PROGRAM_GEN";
    static final private String _ID_SEQ_NAME = "PROGRAM_SEQ";
    @Id
        @SequenceGenerator(name = _ID_GEN_NAME, sequenceName = _ID_SEQ_NAME, allocationSize = 1)
        @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = _ID_GEN_NAME)
//        private Long id;
        private long id;

    @Column(unique = true, nullable = false)
        private String title;

    @Column(nullable = false)
        @Temporal(TemporalType.DATE)
        private Date registeredDate;

    /**
     * Cascade all, not required.
     */
    @JoinColumn(unique=true)
        @OneToOne(optional = true, cascade = CascadeType.ALL)
        ContractTerms contractTerms;

    @Version
        @Column(nullable = false)
        private Long objectVersion;

}
